package com.ejie.ab79.service;
import com.ejie.ab79.dao.PreguntasJsonDao;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.PreguntasJson;

/**
 * PreguntasJsonServiceImpl  
 *  
 */

@Service(value = "preguntasJsonService")
public class PreguntasJsonServiceImpl implements PreguntasJsonService {

	@Autowired
	private PreguntasJsonDao preguntasJsonDao;

	/**
	 * Inserts a single row in the PreguntasJson table.
	 *
	 * @param preguntasJson PreguntasJson
	 * @return PreguntasJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PreguntasJson add(PreguntasJson preguntasJson) {
		return this.preguntasJsonDao.add(preguntasJson);
	}

	/**
	 * Updates a single row in the PreguntasJson table.
	 *
	 * @param preguntasJson PreguntasJson
	 * @return PreguntasJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public PreguntasJson update(PreguntasJson preguntasJson) {
		return this.preguntasJsonDao.update(preguntasJson);
	 }

	/**
	 * Finds a single row in the PreguntasJson table.
	 *
	 * @param preguntasJson PreguntasJson
	 * @return PreguntasJson
	 */
	public PreguntasJson find(PreguntasJson preguntasJson) {
		return (PreguntasJson) this.preguntasJsonDao.find(preguntasJson);
	}
	
	/**
	 * Deletes a single row in the PreguntasJson table.
	 *
	 * @param preguntasJson PreguntasJson
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(PreguntasJson preguntasJson) {
		this.preguntasJsonDao.remove(preguntasJson);
	}

	/**
	 * Finds a list of rows in the PreguntasJson table.
	 *
	 * @param preguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @return List<PreguntasJson>
	 */
	public List<PreguntasJson> findAll(PreguntasJson preguntasJson, TableRequestDto tableRequestDto){
		return (List<PreguntasJson>) this.preguntasJsonDao.findAll(preguntasJson, tableRequestDto);
	}
    
	/**
	 * Finds rows in the PreguntasJson table using like.
	 *
	 * @param preguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
     * @param startsWith Boolean	 
	 * @return List<PreguntasJson>
	 */
	public List<PreguntasJson> findAllLike(PreguntasJson preguntasJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return (List<PreguntasJson>) this.preguntasJsonDao.findAllLike(preguntasJson, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the PreguntasJson table.
	 *
	 * @param filterPreguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		this.preguntasJsonDao.removeMultiple(filterPreguntasJson, tableRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the PreguntasJson table.
	 *
	 * @param filterPreguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<PreguntasJson>
	 */	
	public TableResponseDto< PreguntasJson> filter(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		List<PreguntasJson> listaPreguntasJson =  this.preguntasJsonDao.findAllLike(filterPreguntasJson, tableRequestDto, false);
		Long recordNum =  this.preguntasJsonDao.findAllLikeCount(filterPreguntasJson != null ? filterPreguntasJson: new PreguntasJson (),false);
		
		TableResponseDto<PreguntasJson> usuarioDto = new TableResponseDto<PreguntasJson>(tableRequestDto, recordNum, listaPreguntasJson);
		
		if (tableRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< PreguntasJson>> reorderSelection = this.preguntasJsonDao.reorderSelection(filterPreguntasJson, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds()!=null){
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List< TableRowDto< PreguntasJson>> reorderSeeker = this.preguntasJsonDao.reorderSelection(filterPreguntasJson, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;   
	}
    /**
	 * Searches rows in the PreguntasJson table.
	 *
	 * @param filterPreguntasJson PreguntasJson
	 * @param searchPreguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<PreguntasJson>>
	 */	
    public List< TableRowDto< PreguntasJson>> search(PreguntasJson filterPreguntasJson, PreguntasJson searchPreguntasJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.preguntasJsonDao.search(filterPreguntasJson, searchPreguntasJson, tableRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in PreguntasJson table.
	 *
	 * @param filterPreguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.preguntasJsonDao.reorderSelection(filterPreguntasJson, tableRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the PreguntasJson table.
	 *
	 * @param filterPreguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<JerarquiaDto<PreguntasJson>>
	 */	
	public TableResponseDto<JerarquiaDto<PreguntasJson>> jerarquia(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto, Boolean startsWith){
		List<JerarquiaDto<PreguntasJson>> listaPreguntasJson =  this.preguntasJsonDao.findAllLikeJerarquia(filterPreguntasJson, tableRequestDto);
		Long recordNum = this.preguntasJsonDao.findAllLikeCountJerarquia(filterPreguntasJson, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<PreguntasJson>>(tableRequestDto, recordNum, listaPreguntasJson);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the PreguntasJson table.
	 *
	 * @param filterPreguntasJson PreguntasJson
	 * @param tableRequestDto TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<PreguntasJson>>
	 */	
	public TableResponseDto<JerarquiaDto<PreguntasJson>> jerarquiaChildren(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto){
		TableResponseDto<JerarquiaDto<PreguntasJson>> tableResponseDto = new TableResponseDto<JerarquiaDto<PreguntasJson>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN, this.preguntasJsonDao.findAllChild(filterPreguntasJson, tableRequestDto));
		return tableResponseDto;
	}
	
	/**
    * Exporta Datos al clipBoard
    *
    */
    public List<PreguntasJson> getMultiple(PreguntasJson filterPreguntasJson, TableRequestDto tableRequestDto,  Boolean startsWith){
		return this.preguntasJsonDao.getMultiple(filterPreguntasJson, tableRequestDto, startsWith);
	}
      
	
	
}

